﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.GridHelperClasses;
using Syncfusion.Windows.Forms;
using Syncfusion.Drawing;

namespace WindowsFormsApplication21
{

    public partial class Form1 : Form
    {
        private int recordcount;
        private DataTable table;
        public Form1()
        {

            InitializeComponent();
            
            this.gridGroupingControl1.DataSource = ReturnATable();
            this.gridGroupingControl1.Engine.TableDescriptor.EnableOneTimePopulate();
            this.gridGroupingControl1.ShowGroupDropArea = true;
            this.gridGroupingControl1.TopLevelGroupOptions.ShowFilterBar = true;

            this.gridGroupingControl1.TableOptions.ListBoxSelectionMode = SelectionMode.MultiExtended;
            this.gridGroupingControl1.TableDescriptor.Appearance.FilterBarCell.BackColor = Color.Aqua;
            Syncfusion.Grouping.SortColumnDescriptor cd = new Syncfusion.Grouping.SortColumnDescriptor("Sports");
            this.gridGroupingControl1.TableDescriptor.GroupedColumns.Add(cd);
            this.gridGroupingControl1.TableDescriptor.UnboundFields.Add("Group");
            this.gridGroupingControl1.TableDescriptor.Columns["Group"].Appearance.AnyRecordFieldCell.CellType = "TextBox";
            this.gridGroupingControl1.TableDescriptor.QueryValue += new FieldValueEventHandler(TableDescriptor_QueryValue);
           // this.gridGroupingControl1.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);
            
        }

        void TableDescriptor_QueryValue(object sender, FieldValueEventArgs e)
        {
            int RecordIndex = this.gridGroupingControl1.Table.PrimaryKeySortedRecords.IndexOf(e.Record);
            if (e.Field.Name == "Group")
            {
                if (e.Record.GetValue("Sports") == "Tennis")
                    e.Value = "Group0";
                else if (e.Record.GetValue("Sports") == "FootBall")
                    e.Value = "Group1";
                else if (e.Record.GetValue("Sports") == "Hockey")
                    e.Value = "Group2";
                else
                    e.Value = "Group3";

            }

        }

     
        private DataTable ReturnATable()
        {
            table = new DataTable("People");

            //Adds two columns.
            table.Columns.Add(new DataColumn("FirstName"));
            table.Columns.Add(new DataColumn("LastName"));
            table.Columns.Add(new DataColumn("Sports"));
            table.Columns.Add(new DataColumn("Age"));
            
            //Adds some rows.
            DataRow dr = table.NewRow();
            dr["FirstName"] = "John";
            dr["LastName"] = "Smith";
            dr["Sports"] = "Tennis";
            dr["Age"] = 29;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "Sue";
            dr["LastName"] = "Gaskins";
            dr["Sports"] = "FootBall";
            dr["Age"] = 32;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "John";
            dr["LastName"] = "Jacobs";
            dr["Sports"] = "FootBall";
            dr["Age"] = 56;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "Sam";
            dr["LastName"] = "Garfunkel";
            dr["Sports"] = "Hockey";
            dr["Age"] = 39;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "George";
            dr["LastName"] = "Shepherd";
            dr["Sports"] = "FootBall";
            dr["Age"] = 39;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "Mary";
            dr["LastName"] = "Tucker";
            dr["Sports"] = "Tennis";
            dr["Age"] = 42;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "Sue";
            dr["LastName"] = "Gaskins";
            dr["Sports"] = "FootBall";
            dr["Age"] = 56;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "John";
            dr["LastName"] = "Jacobs";
            dr["Sports"] = "Tennis";
            dr["Age"] = 49;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "Sam";
            dr["LastName"] = "Garfunkel";
            dr["Sports"] = "FootBall";
            dr["Age"] = 40;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "John";
            dr["LastName"] = "Jacobs";
            dr["Sports"] = "Hockey";
            dr["Age"] = 45;
            table.Rows.Add(dr);
                                   
            dr = table.NewRow();
            dr["FirstName"] = "Becky";
            dr["LastName"] = "Dunsford";
            dr["Sports"] = "Cricket";
            dr["Age"] = 33;
            table.Rows.Add(dr);
      
            dr = table.NewRow();
            dr["FirstName"] = "George";
            dr["LastName"] = "Shepherd";
            dr["Sports"] = "BasketBall";
            dr["Age"] = 38;
            table.Rows.Add(dr);

            return table;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.gridGroupingControl1.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = true;
        }

        private void buttonAdv1_Click(object sender, EventArgs e)
        {
            this.gridGroupingControl1.TableDescriptor.GroupedColumns.Clear();
            Syncfusion.Grouping.SortColumnDescriptor cd = new Syncfusion.Grouping.SortColumnDescriptor("Group");
            this.gridGroupingControl1.TableDescriptor.GroupedColumns.Add(cd);
        }
    }
}
